//DOOM levels player by Ivaylo Beltchev
//email: ivob@geocities.com
//url:   http://www.geocities.com/SiliconValley/Bay/2234

#include <dos.h>
#include <mem.h>
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <malloc.h>

#define MAIN_DATA
#include "bsp.h"
#include "move.h"
#include "map.h"
#include "draw.h"

long frames;

void play( void )
{
  while (1) {
    oneframe();
    frames++;
    memcpy(screen,buffer,64000);
    if (!move()) break;
    memset(buffer,0,64000);
  }
}

void initdata( void )
{
  int i;
  double a=atan(1);

  foc=160;
  scr_cols=320;
  scr_rows=200;
  scr_ox=160;
  scr_oy=100;
  for (i=0;i<MAXVD;i++) {
    sintbl[i]=sin(i*8*a/MAXVD);
    costbl[i]=cos(i*8*a/MAXVD);
  }
  for (i=0;i<200;i++)
    table320[i]=i*320;
}

extern void initgr( void );
#pragma aux initgr = \
  " mov eax,0x13 "   \
  " int 0x10"        \
  modify [eax];

extern void tinigr( void );
#pragma aux tinigr = \
  " mov eax,3 "      \
  " int 0x10"        \
  modify [eax];

int setpal( void )
{
  struct {
    char r,g,b;
  } col[256];
  union REGS r;
  struct SREGS s;

  FILE *f=fopen("TEXTURES.PAL","rb");
  if (f) {
    fread(&col,3,256,f);
    r.w.ax=0x1012;
    r.w.bx=0;
    r.w.cx=256;
    r.x.edx=FP_OFF(col);
    segread(&s);
    s.es=FP_SEG(col);
    int386x(0x10,&r,&r,&s);
    fclose(f);
  }
  else return 1;
  f=fopen("PALTBL.DAT","rb");
  if (f) {
    fread(paltbl,256,256,f);
    fclose(f);
  }
  else return 2;
  return 0;
}

void main(int argc,char *argv[])
{
  char s[128];
  int  time;
  char *pt;

  printf("DOOM levels player by Ivaylo Beltchev ivob@geocities.com\n");
  if (argc!=2) {
    printf("Usage: bsp <filename>\r\n");
    return;
  }
  time=*(long *)0x46C;
  if (argc!=2) {
    printf("Usage: bsp <filename>\n");
    return;
  }
  strcpy(s,argv[1]);
  if (!strchr(s,'.')) strcat(s,".BSP");
  if (!readmap(s)) return;
  frames=0;
  buffer=(char *)malloc(64000);
  if (buffer==NULL) {
    printf("No memory for buffer.\n");
    return;
  }
  pt=(char *)malloc(257*256);
  paltbl=(char *)((long)pt&(~255))+256;
  initdata();
  printf("\nKeys:\n  Up/Down    move forward/backward\n  Left/Right rotate left/right\n  Home/PgUp  strafe left/right\n  Gray +/-   move up/down\n\nPress any key...\n" );
  getch();
  initgr();
  char *q=buffer;
  int i=setpal();
  if (i==0) {
    hookkbd();
//    buffer=screen;
    memset(buffer,0,64000);
    play();
    koohkbd();
    tinigr();
    time=*(long *)0x46C-time;
    printf("x=%.0f y=%.0f z=%d d=%d\n",vx,vy,vz,vd);
    printf("fps=%.2f\n",frames*18.2/time);
  }
  else {
    tinigr();
    if (i==1)
      printf("File not found: TEXTURES.PAL\n",s);
     else
      printf("File not found: PALTBL.DAT\n",s);
  }
  freemap();
  free(q);
  free(pt);
}
