#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include "map.h"
#include "bsp.h"
#include "move.h"
#include "draw.h"
#include "drawasm.h"

#define xmin -160
#define xmax  160
#define ymin (-100*65536.)
#define ymax  (100*65536.)

#define flDFLOOR  1
#define flDCEIL   2
#define flDWALL   4
#define flMFLOOR  8
#define flMCEIL  16

char *txwall,*txfloor,*txceiling;
long hceil,hfloor;
int  cols_left;

#define dtofix(a) (a*65536.)

long snc,csc,snh,csh,vxi,vyi;
char txxo,txyo;

double sn,cs;

char infront(int i)
{
  return (tree[i].y1-tree[i].y2)*(tree[i].x1-vx) >
         (tree[i].x1-tree[i].x2)*(tree[i].y1-vy);
}

#define SHADE 512

void drawhorc(int x,int y,int len)
{
  long sx,sy,step,org,beg;
  int shade;
  char *pal;

  if (scr_oy-y+vh!=0) {
    sx=(csc/(scr_oy-y+vh))&65535;
    sy=(snc/(scr_oy-y+vh))&65535;
    step=(sx<<16)-sy;
    org=((vxi+foc*sy)<<16)+((vyi+foc*sx)&65535);
    beg=org+(x-scr_ox)*step;
  }
  else step=0,beg=(vxi<<16)+(vyi&65535);
  if (hceil) {
    shade=SHADE*(scr_oy-y+vh)/hceil;
    if (shade<0) shade=0;
    if (shade>255) shade=255;
    pal=paltbl+shade*256;
  }
  else pal=paltbl+255*256;
  drawcf(buffer+table320[y]+x,len,txceiling,step,beg,pal);
}

void drawhorf(int x,int y,int len)
{
  long sx,sy,step,org,beg;
  int shade;
  char *pal;

  if (y-scr_oy-vh!=0) {
    sx=(csh/(y-scr_oy-vh))&65535;
    sy=(snh/(y-scr_oy-vh))&65535;
    step=(sx<<16)-sy;
    org=((vxi+foc*sy)<<16)+((vyi+foc*sx)&65535);
    beg=org+(x-scr_ox)*step;
  }
  else step=0,beg=(vxi<<16)+(vyi&65535);
  if (hfloor) {
    shade=SHADE*(y-scr_oy-vh)/hfloor;
    if (shade<0) shade=0;
    if (shade>255) shade=255;
    pal=paltbl+shade*256;
  }
  else pal=paltbl+255*256;
  drawcf(buffer+table320[y]+x,len,txfloor,step,beg,pal);
}

void drawpoly1(long x1,long x2,double y1,double dy1,double y2,double dy2,
               char flags,double a1,double a2,double b1,double b2,double b)
{
  long t,step,beg;
  long y,cptr[200],fptr[200];
  long fu1,fd1,fu,fd;
  long cu1,cd1,cu,cd;
  int shade;
  char *pal;
  double stepd;

  x1+=scr_ox;
  x2+=scr_ox;
  y1=scr_oy-y1+vh;
  y2=scr_oy-y2+vh;
  cu1=cd1=uptr[x1];
  fu1=fd1=dptr[x1];
  for (int x=x1;x<x2;x++) {
    int h1,h2;

    if (uptr[x]>=dptr[x]) {
      if (flags&flDCEIL) {
        for (y=cu1;y<cd1;y++)
          if (x-cptr[y]>0) drawhorc(cptr[y],y,x-cptr[y]);
        cu1=cd1;
      }
      if (flags&flDFLOOR) {
        for (y=fu1;y<fd1;y++)
          if (x-fptr[y]>0) drawhorf(fptr[y],y,x-fptr[y]);
        fu1=fd1;
      }
      goto cont;
    }
    h1=y1;
    h2=y2;
    if (h1<uptr[x]) h1=uptr[x];
    if (h2>dptr[x]) h2=dptr[x];
    if (flags&flDCEIL) {
      if (h1>dptr[x]) h1=dptr[x];
      cu=uptr[x];
      cd=h1;
      for (y=cu;y<cu1;y++)
        cptr[y]=x;
      for (y=cd1;y<cd;y++)
        cptr[y]=x;
      for (y=cu1;y<cu;y++)
        if (x-cptr[y]>0) drawhorc(cptr[y],y,x-cptr[y]);
      for (y=cd;y<cd1;y++)
        if (x-cptr[y]>0) drawhorc(cptr[y],y,x-cptr[y]);
      cu1=cu;cd1=cd;
    }
    if (flags&flDFLOOR) {
      if (h2<uptr[x]) h2=uptr[x];
      fu=h2;
      fd=dptr[x];
      for (y=fu;y<fu1;y++)
        fptr[y]=x;
      for (y=fd1;y<fd;y++)
        fptr[y]=x;
      for (y=fu1;y<fu;y++)
        if (x-fptr[y]>0) drawhorf(fptr[y],y,x-fptr[y]);
      for (y=fd;y<fd1;y++)
        if (x-fptr[y]>0) drawhorf(fptr[y],y,x-fptr[y]);
      fu1=fu;fd1=fd;
    }
    if ((flags&flMCEIL ) && h2>uptr[x]) uptr[x]=h2;
    if ((flags&flMFLOOR) && h1<dptr[x]) dptr[x]=h1;
    if (uptr[x]>=dptr[x]) cols_left--;
    stepd=b/b1;
    shade=SHADE/stepd;
    if (shade<0) shade=0;
    if (shade>255) shade=255;
    pal=paltbl+shade*256;
    step=dtofix(stepd);
    beg=(h1-scr_oy-vh)*step-(txyo+vz)*65536;
    t=a1/b1+txxo;
    if (h2-h1>0)
      drawwall(buffer+table320[h1]+x,h2-h1,txwall+((t&127)<<7),step,beg,pal);
 cont:
    a1+=a2;
    b1+=b2;
    y1-=dy1;
    y2-=dy2;
  }
  if (flags&flDCEIL)
    for (y=cu1;y<cd1;y++)
      if (x-cptr[y]>0) drawhorc(cptr[y],y,x-cptr[y]);
  if (flags&flDFLOOR)
    for (y=fu1;y<fd1;y++)
      if (x-fptr[y]>0) drawhorf(fptr[y],y,x-fptr[y]);
}

void drawpoly2(long x1,long x2,double y1,double dy1,double y2,double dy2,
               char flags)
{
  long y,lptr[200];
  long fu1,fd1,fu,fd;
  long cu1,cd1,cu,cd;

  x1+=scr_ox;
  x2+=scr_ox;
  y1=scr_oy-y1+vh;
  y2=scr_oy-y2+vh;
  cu1=cd1=uptr[x1];
  fu1=fd1=dptr[x1];
  for (int x=x1;x<x2;x++) {
    int h1,h2;
    if (uptr[x]>=dptr[x]) {
      if (flags&flDCEIL) {
        for (y=cu1;y<cd1;y++)
          if (x-lptr[y]>0) drawhorc(lptr[y],y,x-lptr[y]);
        cu1=cd1;
      }
      if (flags&flDFLOOR) {
        for (y=fu1;y<fd1;y++)
          if (x-lptr[y]>0) drawhorf(lptr[y],y,x-lptr[y]);
        fu1=fd1;
      }
      goto cont;
    }
    h1=y1;
    h2=y2;
    if (h1<uptr[x]) h1=uptr[x];
    if (h2>dptr[x]) h2=dptr[x];
    if (flags&flDCEIL) {
      if (h1>dptr[x]) h1=dptr[x];
      cu=uptr[x];
      cd=h1;
      for (y=cu;y<cu1;y++)
        lptr[y]=x;
      for (y=cd1;y<cd;y++)
        lptr[y]=x;
      for (y=cu1;y<cu;y++)
        if (x-lptr[y]>0) drawhorc(lptr[y],y,x-lptr[y]);
      for (y=cd;y<cd1;y++)
        if (x-lptr[y]>0) drawhorc(lptr[y],y,x-lptr[y]);
      cu1=cu;cd1=cd;
    }
    if (flags&flDFLOOR) {
      if (h2<uptr[x]) h2=uptr[x];
      fu=h2;
      fd=dptr[x];
      for (y=fu;y<fu1;y++)
        lptr[y]=x;
      for (y=fd1;y<fd;y++)
        lptr[y]=x;
      for (y=fu1;y<fu;y++)
        if (x-lptr[y]>0) drawhorf(lptr[y],y,x-lptr[y]);
      for (y=fd;y<fd1;y++)
        if (x-lptr[y]>0) drawhorf(lptr[y],y,x-lptr[y]);
      fu1=fu;fd1=fd;
    }
    if ((flags&flMCEIL ) && h1>uptr[x]) uptr[x]=h1;
    if ((flags&flMFLOOR) && h2<dptr[x]) dptr[x]=h2;
 cont:
    y1-=dy1;
    y2-=dy2;
  }
  if (flags&flDCEIL)
    for (y=cu1;y<cd1;y++)
      if (x-lptr[y]>0) drawhorc(lptr[y],y,x-lptr[y]);
  if (flags&flDFLOOR)
    for (y=fu1;y<fd1;y++)
      if (x-lptr[y]>0) drawhorf(lptr[y],y,x-lptr[y]);
}

void draw1(int i)
{
  double wx,wx1,wy1,wx2,wy2;
  double a,b,c,dx,dy,y1,y2,dy1,dy2;
  long h1,h2,dh1,dh2;
  double x1,x2;
  double a1,a2,b1,b2;
  char fl;

  wx1=tree[i].x1-vx;
  wy1=tree[i].y1-vy;
  wx2=tree[i].x2-vx;
  wy2=tree[i].y2-vy;
  wx=wx1*cs-wy1*sn;
  wy1=wx1*sn+wy1*cs;
  wx1=wx;
  wx=wx2*cs-wy2*sn;
  wy2=wx2*sn+wy2*cs;
  wx2=wx;
  if (wy1<0 && wy2<0) return;
  b=wx1*wy2-wx2*wy1;
  if (b==0) return;
  dy=wy2-wy1;
  dx=wx2-wx1;
  if (wy1>=0) {
    x1=wx1*foc/wy1;
    if (x1<xmin) x1=xmin;
  }
  else x1=xmin;
  if (wy2>=0) {
    x2=wx2*foc/wy2;
    if (x2>xmax) x2=xmax;
  }
  else x2=xmax;
  if (x1>=x2) return;
  fl=flDFLOOR|flMFLOOR;
  if (tree[i].h2==tree[i].h3) fl|=flDCEIL|flMCEIL;
  h1=((fl&flDCEIL)?tree[i].h4:tree[i].h2)-vz;
  h2=tree[i].h1-vz;
  dh1=dh2=0;
  a=h1*dy-dh1*wy1;
  c=dh1*wx1-h1*dx;
  y1=(a*x1+c*foc)/b;
  dy1=a/b;
  a=h2*dy-dh2*wy1;
  c=dh2*wx1-h2*dx;
  y2=(a*x1+c*foc)/b;
  dy2=a/b;
  txwall=txwalls[tree[i].txw-1];
  txfloor=txfloors[tree[i].txff-1];
  txceiling=txfloors[tree[i].txfc-1];
  txxo=tree[i].xo;
  txyo=tree[i].yo;
  hceil=tree[i].h4-vz;
  hfloor=vz-tree[i].h1;
  snc=hceil*1024*sn;
  csc=hceil*1024*cs;
  snh=hfloor*1024*sn;
  csh=hfloor*1024*cs;
  a1=tree[i].len*(foc*wx1-x1*wy1);
  a2=-tree[i].len*wy1;
  b1=x1*dy-foc*dx;
  b2=dy;
  drawpoly1(x1,x2,y1,dy1,y2,dy2,fl,a1,a2,b1,b2,b);
  if (fl&flDCEIL) return;
  h1=tree[i].h4-vz;
  h2=tree[i].h3-vz;
  dh1=dh2=0;
  if (b) {
    a=h1*dy-dh1*wy1;
    c=dh1*wx1-h1*dx;
    y1=(a*x1+c*foc)/b;
    dy1=a/b;
    a=h2*dy-dh2*wy1;
    c=dh2*wx1-h2*dx;
    y2=(a*x1+c*foc)/b;
    dy2=a/b;
  }
  else {
    y1=(h1<0)?ymin:ymax;
    dy1=0;
    y2=(h2<0)?ymin:ymax;
    dy2=0;
  }
  fl=flDCEIL|flMCEIL;
  drawpoly1(x1,x2,y1,dy1,y2,dy2,fl,a1,a2,b1,b2,b);
}

void draw2(int i)
{
  double wx,wx1,wy1,wx2,wy2;
  double a,b,c,dx,dy,y1,y2,dy1,dy2;
  long h1,h2,dh1,dh2;
  double x1,x2;
  char fl;

  if (tree[i].h2==tree[i].h3) return;
  wx2=tree[i].x1-vx;
  wy2=tree[i].y1-vy;
  wx1=tree[i].x2-vx;
  wy1=tree[i].y2-vy;
  wx=wx1*cs-wy1*sn;
  wy1=wx1*sn+wy1*cs;
  wx1=wx;
  wx=wx2*cs-wy2*sn;
  wy2=wx2*sn+wy2*cs;
  wx2=wx;
  if (wy1<0 && wy2<0) return;
  b=wx1*wy2-wx2*wy1;
  if (b==0) return;
  dy=wy2-wy1;
  dx=wx2-wx1;
  if (wy1>=0) {
    x1=wx1*foc/wy1;
    if (x1<xmin) x1=xmin;
  }
  else x1=xmin;
  if (wy2>=0) {
    x2=wx2*foc/wy2;
    if (x2>xmax) x2=xmax;
  }
  else x2=xmax;
  if (x1>=x2) return;
  h1=tree[i].h3-vz;
  h2=tree[i].h2-vz;
  dh1=dh2=0;
  a=h1*dy-dh1*wy1;
  c=dh1*wx1-h1*dx;
  y1=(a*x1+c*foc)/b;
  dy1=a/b;
  a=h2*dy-dh2*wy1;
  c=dh2*wx1-h2*dx;
  y2=(a*x1+c*foc)/b;
  dy2=a/b;
  txfloor=txfloors[tree[i].txbf-1];
  txceiling=txfloors[tree[i].txbc-1];
  hceil=tree[i].h3-vz;
  hfloor=vz-tree[i].h2;
  snc=hceil*1024*sn;
  csc=hceil*1024*cs;
  snh=hfloor*1024*sn;
  csh=hfloor*1024*cs;
  fl=flDFLOOR|flMFLOOR|flDCEIL|flMCEIL;
  drawpoly2(x1,x2,y1,dy1,y2,dy2,fl);
}

void walktree(int i)
{
  if (!cols_left) return;
  if (infront(i)) {
    if (tree[i].r) walktree(tree[i].r);
    draw1(i);
    if (!cols_left) return;
    if (tree[i].l) walktree(tree[i].l);
  }
  else {
    if (tree[i].l) walktree(tree[i].l);
    draw2(i);
    if (!cols_left) return;
    if (tree[i].r) walktree(tree[i].r);
  }
}

void drawgun( void )
{
  int gunx,guny,x;

  gunx=(20*sintbl[guni]);
  guny=abs(10*costbl[guni]);
  for (x=0;x<GUNX;x++)
    drawgunv(buffer+table320[200-GUNY+guny]+160-GUNX/2+x+gunx,GUNY-guny,gunbmp[x]);
}

void oneframe( void )
{
  sn=sintbl[vd];
  cs=costbl[vd];
  vxi=(int)(vx*1024)&65535;
  vyi=(int)(vy*1024)&65535;
  for (int i=0;i<scr_cols;i++) {
    uptr[i]=0;
    dptr[i]=scr_rows;
  }
  cols_left=scr_cols;
  walktree(0);
  drawgun();
}
