#include <math.h>
#include <stdio.h>
#include <malloc.h>
#include "map.h"
#include "move.h"

int readgun( void )
{
  FILE *f=fopen("GUN.BMP","rb");
  if (f==NULL) {
    printf("File not found: GUN.BMP\n");
    return 0;
  }
  fseek(f,0x436,SEEK_SET);
  fread(gunbmp,sizeof(gunbmp),1,f);
  fclose(f);
  return 1;
}

int readwall(int n)
{
  char s[30];

  sprintf(s,"WALL%02d.BMP",n);
  txwalls[n-1]=(char *)malloc(128*128);
  if (txwalls[n-1]==NULL) {
    printf("No memory.\n");
    return 0;
  }
  FILE *f=fopen(s,"rb");
  if (f==NULL) {
    printf("File not found: %s\n",s);
    return 0;
  }
  fseek(f,0x436,SEEK_SET);
  fread(txwalls[n-1],128*128,1,f);
  for (int x=0;x<128;x++)
    for (int y=0;y<x;y++) {
      char q=*(txwalls[n-1]+x*128+y);
      *(txwalls[n-1]+x*128+y)=*(txwalls[n-1]+y*128+x);
      *(txwalls[n-1]+y*128+x)=q;
    }
  fclose(f);
  return 1;
}

int readfloor(int n)
{
  char s[30];

  sprintf(s,"FLOOR%02d.BMP",n);
  txfloors[n-1]=(char *)malloc(64*64);
  if (txfloors[n-1]==NULL) {
    printf("No memory.\n");
    return 0;
  }
  FILE *f=fopen(s,"rb");
  if (f==NULL) {
    printf("File not found: %s\n",s);
    return 0;
  }
  fseek(f,0x436,SEEK_SET);
  fread(txfloors[n-1],64*64,1,f);
  fclose(f);
  return 1;
}

int readmap(char *name)
{
  FILE *f;
  int  i,xo,yo;

  for (i=0;i<10;i++)
    txwalls[i]=txfloors[i]=NULL;
  if (!readgun()) return 0;
  f=fopen(name,"rt");
  if (f==NULL) {
    printf("File not found: %s\n",name);
    return 0;
  }
  fscanf(f,"%d %d %d %d %d",&wall_num,&xo,&yo,&vz,&vd);
  vx=xo;
  vy=yo;
  vh=0;
  vz0=vz;
  vdz=0;
  for (i=0;i<wall_num;i++) {
    fscanf(f,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
              &tree[i].x1,&tree[i].y1,&tree[i].x2,&tree[i].y2,
              &tree[i].h1,&tree[i].h2,&tree[i].h3,&tree[i].h4,
              &tree[i].txw,&tree[i].txff,&tree[i].txfc,&tree[i].txbf,&tree[i].txbc,
              &xo,&yo,&tree[i].l,&tree[i].r);
    tree[i].xo=xo;
    tree[i].yo=yo;
    double dx=tree[i].x2-tree[i].x1;
    double dy=tree[i].y2-tree[i].y1;
    tree[i].len=sqrt(dx*dx+dy*dy);
    if (txwalls[tree[i].txw-1]==NULL)
      if (!readwall(tree[i].txw)) return 0;
    if (txfloors[tree[i].txff-1]==NULL)
      if (!readfloor(tree[i].txff)) return 0;
    if (txfloors[tree[i].txfc-1]==NULL)
      if (!readfloor(tree[i].txfc)) return 0;
    if (txfloors[tree[i].txbf-1]==NULL)
      if (!readfloor(tree[i].txbf)) return 0;
    if (txfloors[tree[i].txbc-1]==NULL)
      if (!readfloor(tree[i].txbc)) return 0;
  }
  fclose(f);
  return 1;
}

void freemap( void )
{
  int i;

  for (i=0;i<10;i++) {
    if (txwalls[i]) free(txwalls[i]);
    if (txfloors[i]) free(txfloors[i]);
  }
}
