#include <assert.h>
#include <malloc.h>
#include <stdio.h>
#include <conio.h>

#define C 0.99

struct {
  char r,g,b;
} pal[256];

typedef char Trow[256];

Trow *table;

void readpal( void )
{
  FILE *f=fopen("TEXTURES.PAL","rb");
  fread(&pal,3,256,f);
  fclose(f);
}

void maketbl( void )
{
  int i,j;
  double c;

  for (j=0;j<255;j++) {
    c=j/256.;
    for (i=0;i<256;i++) {
      double d,r,g,b;
      int k,m;

      r=pal[i].r*c;
      g=pal[i].g*c;
      b=pal[i].b*c;
      m=0;
      d=65536.*3;
      for (k=0;k<256;k++) {
        double d1=(r-pal[k].r)*(r-pal[k].r)+(g-pal[k].g)*(g-pal[k].g)+
                  (b-pal[k].b)*(b-pal[k].b);
        if (d1<d) m=k,d=d1;
      }
      table[j][i]=m;
    }
    cprintf(".");
  }
}

void writetbl( void )
{
  FILE *f;
  Trow row;
  int i;

  for (i=0;i<256;i++)
    row[i]=i;
  f=fopen("PALTBL.DAT","wb");
  fwrite(table,255,256,f);
  fwrite(row,1,256,f);
  fclose(f);
  cprintf("\nDone.\n");
}

void main( void )
{
  table=(Trow *)malloc(65280);
  assert(table);
  readpal();
  maketbl();
  writetbl();
}
